SystemOrganization addCategory: #'TP2-Parte2'!
SystemOrganization addCategory: #'TP2-Parte2-Pruebas'!
SystemOrganization addCategory: #'TP2-Parte2-Test'!

Object subclass: #CaninoGemelo
	instanceVariableNames: 'velocidad potencia mordida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte2-Pruebas'!

Object subclass: #Perro
	instanceVariableNames: 'hambre vida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte2'!

Perro class
	instanceVariableNames: 'hambre vida'!

Perro class
	instanceVariableNames: 'hambre vida'!

!Perro methodsFor: 'as yet unclassified' stamp: 'Tomas 5/6/2013 21:50'!
InicializarSuVida: cantidadVida suHambre: cantidadHambre
	self  vida: cantidadVida .
	self hambre: cantidadHambre .
	^self.! !

!Perro methodsFor: 'as yet unclassified' stamp: 'Tomas 5/6/2013 21:40'!
caminar
	self hambre: (self hambre + 2).! !

!Perro methodsFor: 'as yet unclassified' stamp: 'Tomas 5/6/2013 21:39'!
comer
	self hambre: (self hambre - 10).
	self vida: (self vida + 10).! !

!Perro methodsFor: 'as yet unclassified' stamp: 'Demian 4/27/2013 10:32'!
estaEnojado
	^ self hambre > 20! !

!Perro methodsFor: 'accessing' stamp: 'Demian 4/27/2013 10:31'!
hambre
	^ hambre! !

!Perro methodsFor: 'accessing' stamp: 'Tomas 5/6/2013 21:38'!
hambre: unaCantidad
	hambre := unaCantidad.! !

!Perro methodsFor: 'accessing' stamp: 'Tomas 5/4/2013 01:10'!
vida
	^ vida.! !

!Perro methodsFor: 'accessing' stamp: 'Tomas 5/4/2013 01:10'!
vida: unaCantidad
	vida := unaCantidad.! !

Object subclass: #RefactorEjemplo
	instanceVariableNames: 'metodosConPatron atributosConPatron'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte2'!

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/9/2013 01:16'!
agregar:unaNuevaClase En:unaClase

|nuevaclase atributosConSusMetodos metodosSinRepetir|
	nuevaclase := (Object  subclass: unaNuevaClase
					instanceVariableNames:''
					classVariableNames:''  
					poolDictionaries:'' 
					category: unaClase category).

	atributosConPatron  do:[:a| nuevaclase addInstVarNamed: a]. "agrega atributos"

	unaClase addInstVarNamed: unaNuevaClase. "agraga la variable de la nueva clase"

	unaClase methodDictionary do:[:m| nuevaclase compile: m getSource ].

	atributosConSusMetodos :=self atributosConSusMetodosDe: unaClase.

	metodosSinRepetir := atributosConSusMetodos inject: Set new into: [:acum :a| acum union: a].

	metodosSinRepetir do:[:a| nuevaclase removeSelector: a]! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/8/2013 23:45'!
atributosConSusMetodosDe: unaClase
	
	^ (unaClase instVarNames collect: [:m | unaClase whichSelectorsAccess: m]). ! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/8/2013 23:55'!
eliminarAtributosDe: unaClase

	atributosConPatron  do:[:a|unaClase removeInstVarNamed:a].! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/8/2013 23:54'!
eliminarMetodosDe: unaClase

	metodosConPatron  do:[:m| unaClase  removeSelector:m].! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/8/2013 23:34'!
esProblematica: unaClase

|atributosConSusMetodos atributosConSusMetodosSinRepetir|

	metodosConPatron := Set new.
	atributosConPatron := Set new.

	atributosConSusMetodos := self atributosConSusMetodosDe: unaClase.       "Selecciono los metodos que tienen atributos"

	metodosConPatron := self obtenerMetodosConPatronDe: atributosConSusMetodos .

	atributosConSusMetodosSinRepetir:= metodosConPatron inject: Set new into:[:acum :m| acum union: m].
	
	atributosConPatron:= self obtenerAtributosConPatronDe: unaClase .

	^ (metodosConPatron size = unaClase methodDictionary size) not. "Si la cantidad de metodos es igual a la de los metodos de la claase entonces estan todos conectados y no hay incomexos"
! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/8/2013 23:33'!
obtenerAtributosConPatronDe: unaClase 

^ ((unaClase instVarNames) select:[:a| metodosConPatron anySatisfy:[:m| (unaClase whichSelectorsAccess: a) includes:m]]).! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/8/2013 23:29'!
obtenerMetodosConPatronDe: atributosMetodos
	|met|
	
	met := atributosMetodos inject: (atributosMetodos first:1)
					into: [:acum :metodos | (metodos anySatisfy: [:m | acum includes: m])
							ifTrue:[ acum union: metodos] 
							ifFalse: [acum] ].
						
	^  met inject: Set new into:[:acum :m| acum union: m].! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/9/2013 01:11'!
refactorizar: unaClase Como: nombreClase 
	(self esProblematica:  unaClase)
		ifTrue:[self agregar:nombreClase  En: unaClase;
	                eliminarAtributosDe:  unaClase;
			    eliminarMetodosDe:  unaClase ].! !

Object subclass: #SuperCanino
	instanceVariableNames: 'velocidad potencia mordida salto vision CaninoGemelo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte2-Pruebas'!

!SuperCanino methodsFor: 'as yet unclassified' stamp: 'Tomas 5/9/2013 01:21'!
habilidadatajando
                                       ^vision+salto! !

Object subclass: #TP2Pruebas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte2-Pruebas'!

!TP2Pruebas methodsFor: 'as yet unclassified' stamp: 'Tomas 5/4/2013 12:46'!
originaltest
	"esto no hace nada"! !

!TP2Pruebas methodsFor: 'as yet unclassified' stamp: 'Tomas 5/4/2013 12:45'!
originaltest1
			|  returnValue |
			"un comentario"
			returnValue := self originaltest1.
			"otro comentario"
			^returnValue.! !

!TP2Pruebas methodsFor: 'as yet unclassified' stamp: 'Tomas 5/4/2013 12:42'!
originaltest2
			|  returnValue |
			"comentario"
			returnValue := self originaltest2.
			test1= 2.
			^returnValue.! !

!TP2Pruebas methodsFor: 'as yet unclassified' stamp: 'Tomas 5/4/2013 12:46'!
originaltest3
	"esto no hace nada"! !

!TP2Pruebas methodsFor: 'as yet unclassified' stamp: 'Tomas 5/4/2013 12:42'!
test
	"esto no hace nada"! !

!TP2Pruebas methodsFor: 'as yet unclassified' stamp: 'Tomas 5/4/2013 12:45'!
test1
			|  returnValue |
			"un comentario"
			returnValue := self originaltest1.
			"otro comentario"
			^returnValue.! !

!TP2Pruebas methodsFor: 'as yet unclassified' stamp: 'Tomas 5/4/2013 12:42'!
test2
			|  returnValue |
			"comentario"
			returnValue := self originaltest2.
			test1= 2.
			^returnValue.! !

!TP2Pruebas methodsFor: 'as yet unclassified' stamp: 'rodrigosouto 5/4/2013 05:13'!
test3
	"esto no hace nada"! !

Object subclass: #TheBlobPruebas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte2-Pruebas'!

TestCase subclass: #TestTP2Parte2
	instanceVariableNames: 'refactor unaClase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte2-Test'!

!TestTP2Parte2 methodsFor: 'as yet unclassified' stamp: 'Tomas 5/9/2013 00:53'!
setUp

	unaClase := (Object subclass: #SuperCanino  
					instanceVariableNames:'velocidad potencia mordida salto vision'
					classVariableNames:'' 
					poolDictionaries:''  
					category: 'TP2-Parte2-Pruebas').

	unaClase compile:'habilidadgoleadora
                                      ^velocidad+mordida+potencia'.

	unaClase compile:'habilidadmediocampo 
                                      ^velocidad+potencia'.

	unaClase compile: 'habilidadatajando
                                       ^vision+salto'.

	refactor := RefactorEjemplo  new.! !

!TestTP2Parte2 methodsFor: 'as yet unclassified' stamp: 'Tomas 5/9/2013 00:46'!
testEsProblematico
	"Testea si una Clase es Problematica"

	self assert: (refactor esProblematica: unaClase).! !

!TestTP2Parte2 methodsFor: 'as yet unclassified' stamp: 'Tomas 5/9/2013 01:25'!
testRefactor
|cantidadAtributosAntesRefactor cantidadAtributosDespuesRefactor|

	cantidadAtributosAntesRefactor := unaClase  instVarNames size.

	refactor refactorizar:  unaClase Como: #CaninoGemelo.

	cantidadAtributosDespuesRefactor := unaClase instVarNames size.

	self assert: ( cantidadAtributosAntesRefactor > cantidadAtributosDespuesRefactor ).! !
